#include "define.h"
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#include <io.h>
#include <stdarg.h>
#include <alloc.h>
#include "globals.h"
#include "util_bw.h"
#include "mouse.h"
#include "ripscrip.h"

extern int disable_text_window;
extern int curr_x_adj;
extern int curr_y_adj;
extern int curr_y_ofs;

extern void logger(byte*);
extern void reset_font(void);
extern void enter_rip_text_window(void);
extern void MoveImage(int,int,int,int,int,int);
extern char *farPtr(char*,long);
extern byte *Boolean(int);
extern void _cdecl rbmove(unsigned,unsigned,unsigned,int,int,int,int);
extern void _cdecl fbmove(unsigned,unsigned,unsigned,int,int,int,int);
extern void _cdecl video_wr(unsigned,unsigned,int,int);
extern void _fastcall bvideo(int);
extern int detect_vga(void);
extern int detect_ega(void);

extern char kbd_status;
extern unsigned char last_line;
extern int RIP_Window;

#define Ofs(ptr) ((unsigned)((unsigned long) ptr))

extern int crtmode;
extern screen_array_ptr scr_ptr;
extern int current_text_attr;
extern int cursor_blanked;
extern int cursor_thickness;
extern unsigned scr_numrows_minus1;
extern unsigned scr_numrows;
extern unsigned original_length;
extern unsigned scr_numcols_minus1;
extern unsigned scr_numcols;
extern unsigned original_width;
extern int GrNoScroll;
extern char bios_video[6];

extern int current_background;
extern int current_foreground;
extern unsigned scr_seg;
extern int max_window_ofs;   /***  (25 * 160 - 2)  ***/
extern int max_x_coord;
extern int max_y_coord;
extern int min_x_coord;
extern int min_y_coord;
extern int carriage_return_ofs;
extern int no_retrace_wait;
extern int original_crtmode;
extern int ega_found;
extern int vga_found;
extern int mda_found;
extern int cga_found;
extern int ms_status;
extern int dv_found;
extern int dos_major_version;
extern int dos_minor_version;
extern int yield_idle_time;
extern int windoze_found;
extern int dv_major_version;
extern int dv_minor_version;
extern int win_major_version;
extern int win_minor_version;
extern unsigned long low_deferred;
extern unsigned long hi_deferred;
extern int deferred_update;

void ClearScreenBuffer(int,int,int,int);
struct settings *save_settings(void);
void restore_settings(struct settings *);
void GrWriteTextXY(int*,int*,char*);
unsigned calc_ofs(unsigned,unsigned);
extern void cleanup(unsigned,unsigned);
extern unsigned BiosScrLen(void);
int x_coord(unsigned);
int y_coord(unsigned);
unsigned xy_to_ofs(unsigned *,unsigned *);
void tell_dv(int *,int *);
void begin_deferred_dv_update(void);
void end_deferred_dv_update(void);
void wf_gotoxy(int,int);
void carriage_return(unsigned *,unsigned *);
void teletype_biosvideo_wrt(int);
void scroll_dv(void);
void tell_dv_line(int);
void wf_scroll_right(int);
void wf_scroll_left(int);
void wf_scroll(void);
void DrawCursor(void);
int GrTextWidth(void);
int GrTextHeight(void);
void ClearArea(int,int,int,int,int);

struct settings *save_settings(void)
{
    struct settings *p;

    p = (struct settings *) farmalloc(sizeof(struct settings));
    if (p == NULL)
        return(NULL);
    getviewsettings(&p->viewport);
    p->curr_fore_color = getcolor();
    p->curr_back_color = GrBackground;
    getfillsettings(&p->fillinfo);
    if (p->fillinfo.pattern == 12)
        getfillpattern(p->user_pattern);
    getlinesettings(&p->lineinfo);
    p->font_size = RIPfontsize;
    return(p);
}

void restore_settings(struct settings *p)
{
    if (p == NULL)
        return;
    setcolor(p->curr_fore_color);
    GrBackground = p->curr_back_color;
    if (p->fillinfo.pattern == 12)
        setfillpattern(p->user_pattern,p->fillinfo.color);
    else
        setfillstyle(p->fillinfo.pattern,p->fillinfo.color);
    setlinestyle(p->lineinfo.linestyle,p->lineinfo.upattern,p->lineinfo.thickness);
    setviewport(
        p->viewport.left, p->viewport.top,
        p->viewport.right,p->viewport.bottom,
        p->viewport.clip
        );
    RIPfontsize = p->font_size;
    farfree(p);
}

void draw_cursor(void)
{
    int x0, y0, x1, y1;
    int incr, j;
    struct settings *p;

    p = save_settings();
    setcolor(WHITE);
    setlinestyle(SOLID_LINE,0xFFFF,NORM_WIDTH);
    incr = 0;
    if (cursor_thickness == SKINNY_CURSOR)
        incr = GrTextHeight() - 1;
    x0 = GrTextCurrX;
    y0 = GrTextCurrY + incr;
    x1 = x0 + GrTextWidth() - 1;
    y1 = y0 + 2;
    setwritemode(XOR_PUT);
    for (j=y0; j<y1; j++)
        line(x0,j,x1,j);
    setwritemode(COPY_PUT);
    restore_settings(p);
}

void DrawCursor(void)
{
    if (!cursor_blanked)
        draw_cursor();
}

void GrWriteString(int x,int y,byte *s,int w,int th,unsigned attr,int up_scrn_buff)
{
    int ix, iy, j;
    unsigned ch;

#ifdef DEBUG
    stack_probe();
#endif
    setcolor(attr & 0x0F);
    GrBackground = (attr >> 4) & 0x07;
    ClearArea(x-curr_x_adj,
               y+curr_y_adj,
                x+w-1,
                 y+th-1+curr_y_adj,
                  up_scrn_buff);
    outtextxy(x,y-curr_y_ofs,s);
    if (up_scrn_buff) {
        ix = x / GrTextWidth();
        iy = y / GrTextHeight();
        for (j=0; (ch = s[j]); j++)
            (*screen_image)[iy][ix++] = (attr << 8) | ch;
    }
}

void GrWriteTextXY(int *x,int *y,char *buf)
{
    char *p;
    byte wbuf[256];
    int tot_w, chars_per_line, ix, iy, j;
    unsigned ch;
    int curr_x, curr_y, n, total_n, tw, th, max_y, max_x, num_of_lines;

#ifdef DEBUG
    stack_probe();
#endif
    p = buf;
    curr_x = *x;
    curr_y = *y;
    tw = GrTextWidth();
    th = GrTextHeight();
    num_of_lines   = (GrTextMaxY + 1) / th;
    chars_per_line = (GrTextMaxX + 1) / tw;
    max_x = (chars_per_line - 1) * tw;
    max_y = (num_of_lines - 1)   * th;
    total_n = strlen(p);
    while (total_n) {
        n = (GrTextMaxX - curr_x + 1) / tw;
        if (n > total_n)
            n = total_n;
        else
            if (n < 1)
                n = 1;
        total_n -= n;
        strncpy(wbuf,p,n);
        wbuf[n] = 0;
        tot_w = n * tw;
        ClearArea(curr_x-curr_x_adj,
                   curr_y+curr_y_adj,
                    curr_x+tot_w-1,
                     curr_y+th-1+curr_y_adj,
                      FALSE);
        outtextxy(curr_x,curr_y-curr_y_ofs,wbuf);
        ix = (curr_x + GrTextLeft) / tw;
        iy = (curr_y + GrTextTop ) / th;
        for (j=0; (ch = wbuf[j]); j++)
            (*screen_image)[iy][ix++] = (current_text_attr << 8) | ch;
        if (total_n) {
            if (GrNoScroll)
                goto IncrementX;
            curr_x = 0;
            curr_y += th;
        }
        else {
            p = farPtr(p,(long) n);
IncrementX:
            if ((curr_x += tot_w) > max_x) {
                if (GrNoScroll) {
                    curr_x -= tot_w;
                }
                else {
                    curr_x = 0;
                    curr_y += th;
                }
            }
        }
        if (curr_y > max_y) {
            wf_scroll();
            curr_y -= th;
        }
    }
    *x = curr_x;
    *y = curr_y;
}

void g_puts(char *str)
{
    char buf[256];
    int blanked_cursor;
    int x, y, max_y, nl;
    int i, j, ch, tw, th;

#ifdef DEBUG
    stack_probe();
#endif
    if ((GrTextLeft == GrTextRight)||(disable_text_window))
        return;
    reset_font();
    setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
    if (ms_status)
        ms_hide();
    blanked_cursor = cursor_blanked;
    if (!blanked_cursor)
        cursor_off();
    tw = GrTextWidth();
    th = GrTextHeight();
    nl = (GrTextMaxY + 1) / th;
    max_y = (nl - 1) * th;
    buf[0] = 0;
    i = 0;
    x = max(GrTextCurrX,0);
    y = max(GrTextCurrY,0);
    for (j=0; (ch = str[j]); j++) {
        switch (ch) {
            case '\b':
                if (buf[0]) {
                    GrWriteTextXY(&x,&y,buf);
                    i = 0;
                    buf[0] = 0;
                }
                if ((x -= tw) < 0)
                    x = 0;
                break;
            case '\r':
                if (buf[0]) {
                    GrWriteTextXY(&x,&y,buf);
                    i = 0;
                    buf[0] = 0;
                }
                x = 0;
                break;
            case '\n':
                if (buf[0]) {
                    GrWriteTextXY(&x,&y,buf);
                    i = 0;
                    buf[0] = 0;
                }
                if ((y += th) > max_y) {
                    if (RIPwrapmode)
                        wf_scroll();
                    y = max_y;
                }
                break;
            default:
                buf[i++] = ch;
                buf[i]   = 0;
                if (i > 250) {
                    GrWriteTextXY(&x,&y,buf);
                    i = 0;
                    buf[0] = 0;
                }
                break;
        }
    }
    if (i)
        GrWriteTextXY(&x,&y,buf);
    GrTextCurrX = x;
    GrTextCurrY = y;
    if (!blanked_cursor)
        cursor_on();
    if (ms_status)
        ms_show();
}

void wf_puts(char *str)
{
    int i, ch;
    union wb_scr_char s;
    unsigned x, y, scr_ofs;
    int *stop_sp;
    int *start_sp;

#ifdef DEBUG
    stack_probe();
#endif
    if (graphics_mode) {
        g_puts(str);
        return;
    }
    if (ms_status)
        ms_hide();
    i = 0;
    if (bios_video[0] == 'F') {
	s.byt.wf_attr = current_text_attr;
	scr_ofs = xy_to_ofs(&x,&y);
	start_sp = MK_SCR_PTR(scr_ofs);
	while (s.byt.wf_char = str[i++]) {
	    switch (s.byt.wf_char) {
		case '\r':
		    carriage_return(&scr_ofs,&x);
		    break;
		case '\n':
		    scr_ofs += 160;
		    break;
		case '\b':
		    if (x > min_x_coord) {
			scr_ofs -= 2;
			x--;
		    }
		    break;
		default:
		    video_wr(scr_seg,scr_ofs,s.wrd.wf_character,no_retrace_wait);
		    if (++x > max_x_coord) {
			carriage_return(&scr_ofs,&x);
			scr_ofs += 160;
		    }
		    else {
			scr_ofs += 2;
		    }
	    }
	    if (scr_ofs > max_window_ofs) {
		wf_scroll();
		scr_ofs -= 160;
	    }
	}
	GGotoXY( x_coord(scr_ofs), y_coord(scr_ofs) );
	stop_sp = MK_SCR_PTR(scr_ofs);
	tell_dv(start_sp,stop_sp);
    }
    else {
	while (ch = str[i++])
	    teletype_biosvideo_wrt(ch);
    }
    if (ms_status)
        ms_show();
}

void scroll_dv(void)
{
    unsigned src_ofs, dest_ofs;

    if (graphics_mode)
        return;
    if (dv_found) {
	src_ofs  = calc_ofs(min_x_coord,min_y_coord);
	dest_ofs = calc_ofs(max_x_coord,max_y_coord);
	tell_dv(MK_SCR_PTR(src_ofs),MK_SCR_PTR(dest_ofs));
    }
}

void tell_dv_line(int y)
{
    unsigned src_ofs, dest_ofs;

    if (graphics_mode)
        return;
    if (dv_found) {
	src_ofs  = calc_ofs(min_x_coord,(unsigned) y);
	dest_ofs = calc_ofs(max_x_coord,(unsigned) y);
	tell_dv(MK_SCR_PTR(src_ofs),MK_SCR_PTR(dest_ofs));
    }
}

void wf_scroll_right(int num_chars)
{
    int dest_ofs, src_ofs, mlen, mdepth;
    union wb_scr_char s;

    s.byt.wf_attr = current_text_attr;
    s.byt.wf_char = ' ';
    dest_ofs = calc_ofs(max_x_coord,min_y_coord);
    src_ofs  = dest_ofs - (num_chars << 1);
    mlen   = (int)(max_x_coord - min_x_coord + 1 - num_chars);
    mdepth = (int)(max_y_coord - min_y_coord + 1);
    if (ms_status)
        ms_hide();
    rbmove(scr_seg,
	   dest_ofs,
	   src_ofs,
	   mlen,
	   s.wrd.wf_character,
	   num_chars,
	   mdepth);
    scroll_dv();
    if (ms_status)
        ms_show();
}

void wf_scroll_left(int num_chars)
{
    int dest_ofs, src_ofs;
    union wb_scr_char s;

    s.byt.wf_attr = current_text_attr;
    s.byt.wf_char = ' ';
    dest_ofs = calc_ofs(min_x_coord,min_y_coord);
    src_ofs  = dest_ofs + (num_chars << 1);
    if (ms_status)
        ms_hide();
    fbmove(scr_seg,
	   dest_ofs,
	   src_ofs,
	   ((int)(max_x_coord - min_x_coord + 1 - num_chars)),
	   s.wrd.wf_character,
	   num_chars,
	   ((int)(max_y_coord - min_y_coord + 1)));
    scroll_dv();
    if (ms_status)
        ms_show();
}

unsigned scr_read(int x,int y)
{
    unsigned ch;

    if (graphics_mode)
        ch = (*screen_image)[y][x];
    else
        ch = scr_rd(x,y);
    return(ch);
}

void wf_inschar(unsigned ch,int num_chars)
{
    unsigned gx, gy;
    int i, oy, max_x, num_ch, blanked_cursor;
    union wb_scr_char s;
    int c1, c2, mlen, th, tw, num_of_chars;
    void *p;
    char str[128];
    int Bottom, Right, width, hold_x, hold_y;
    unsigned dest_ofs, src_ofs, size;

    if (ms_status)
        ms_hide();
    if ((num_ch = num_chars) > scr_numcols)
        num_ch = scr_numcols;
    if (graphics_mode) {
        reset_font();
        setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
        tw     = GrTextWidth();
        th     = GrTextHeight();
        width  = num_ch * tw;
        num_of_chars = ((GrTextMaxX - GrTextCurrX + 1) / tw) - num_ch;
        Right  = GrTextCurrX + (num_of_chars * tw) - 1;
        Bottom = GrTextCurrY + th - 1;
        size   = imagesize(GrTextCurrX,GrTextCurrY,Right,Bottom);
        if ((p = farmalloc(size)) == NULL)
            return;
        blanked_cursor = cursor_blanked;
        if (!blanked_cursor)
            cursor_off();
        hold_x = GrTextCurrX;
        hold_y = GrTextCurrY;
        getimage(GrTextCurrX,GrTextCurrY,Right,Bottom,p);
        putimage(GrTextCurrX+width,GrTextCurrY,p,COPY_PUT);
        farfree(p);
        memset(str,ch,num_ch);
        str[num_ch] = 0;
        GrWriteTextXY(&GrTextCurrX,&GrTextCurrY,str);
        GrTextCurrX = hold_x + width;
        GrTextCurrY = hold_y;
        if (!blanked_cursor)
            cursor_on();
        goto InsCharExit;
    }
    s.byt.wf_attr = current_text_attr;
    s.byt.wf_char = ch;
    get_xy(&gx,&gy);
    if (bios_video[0] == 'F') {
	dest_ofs = calc_ofs(max_x_coord,gy);
	src_ofs  = dest_ofs - (num_chars << 1);
	mlen = (int)(max_x_coord - gx + 1 - num_chars);
	rbmove(scr_seg,
	       dest_ofs,
	       src_ofs,
	       mlen,
	       s.wrd.wf_character,
	       num_chars,
	       1);
	tell_dv_line(gy);
    }
    else {
        max_x = max_x_coord - num_chars + 1;
        oy = gy - 1;
        c1 = max_x_coord - 1;
        c2 = c1 - num_chars;
        for (i = gx; i < max_x; i++)
            scr_wr(c1--,oy,scr_rd(c2--,oy));
        for (c2 = 0; c2 < num_chars; c2++)
	    scr_wr(c1--,oy,s.wrd.wf_character);
    }
    GGotoXY(gx+num_ch,gy);
InsCharExit:
    if (ms_status)
        ms_show();
}

void wf_delchar(int num_chars)
{
    int c1, c2, Right, Bottom, Left, num_ch;
    unsigned dest_ofs, src_ofs, gx, gy, size;
    void *p;
    int oy, max_x, i, tw, th, num_of_chars;
    int hold_x, hold_y, blanked_cursor;
    char str[128];
    union wb_scr_char s;

    if (ms_status)
        ms_hide();
    if ((num_ch = num_chars) > scr_numcols)
        num_ch = scr_numcols;
    if (graphics_mode) {
        reset_font();
        setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
        tw     = GrTextWidth();
        th     = GrTextHeight();
        num_of_chars = ((GrTextMaxX - GrTextCurrX + 1) / tw);
        Left   = GrTextCurrX + (num_ch * tw);
        Right  = GrTextCurrX + (num_of_chars * tw) - 1;
        Bottom = GrTextCurrY + th - 1;
        size   = imagesize(Left,GrTextCurrY,Right,Bottom);
        if ((p = farmalloc(size)) == NULL)
            return;
        blanked_cursor = cursor_blanked;
        if (!blanked_cursor)
            cursor_off();
        hold_x = GrTextCurrX;
        hold_y = GrTextCurrY;
        getimage(Left,GrTextCurrY,Right,Bottom,p);
        putimage(GrTextCurrX,GrTextCurrY,p,COPY_PUT);
        farfree(p);
        memset(str,' ',num_ch);
        str[num_ch] = 0;
        Left = GrTextCurrX + (num_of_chars - num_ch) * tw;
        GrWriteTextXY(&Left,&GrTextCurrY,str);
        GrTextCurrX = hold_x;
        GrTextCurrY = hold_y;
        if (!blanked_cursor)
            cursor_on();
        goto DelCharExit;
    }
    get_xy(&gx,&gy);
    if (bios_video[0] == 'F') {
	s.byt.wf_attr = current_text_attr;
	s.byt.wf_char = ' ';
	dest_ofs = calc_ofs(gx,gy);
	src_ofs  = dest_ofs + (num_ch << 1);
	fbmove(scr_seg,
	       dest_ofs,
	       src_ofs,
	       ((int)(max_x_coord - gx + 1 - num_ch)),
	       s.wrd.wf_character,
	       num_ch,
	       1);
	tell_dv_line(gy);
    }
    else {
        max_x = max_x_coord - num_ch + 1;
        oy = gy - 1;
        c1 = gx - 1;
        c2 = c1 + num_ch;
        for (i = gx; i < max_x; i++)
	    scr_wr(c1++,oy,(scr_rd(c2++,oy)));
        c2 = c1;
        for (i = 0; i < num_ch; i++)
	    scr_wr(c1++,oy,(((scr_rd(c2++,oy)) & 0xff00) | 0x0020));
    }
    GGotoXY(gx,gy);
DelCharExit:
    if (ms_status)
        ms_show();
}

void wf_printf(char *fmt,...)
{
    va_list argptr;
    char str[2048];

    va_start(argptr,fmt);
    vsprintf(str,fmt,argptr);
    va_end(argptr);
    wf_puts(str);
}

void wf_puts_at(int x,int y,char *str)
{
    wf_gotoxy(x,y);
    wf_puts(str);
}

void wf_printf_at(int x,int y,char *fmt,...)
{
    va_list argptr;
    char str[2048];

    va_start(argptr,fmt);
    vsprintf(str,fmt,argptr);
    va_end(argptr);
    wf_puts_at(x,y,str);
}

void wf_delline(int up_scrn_buff)
{
    int th, nl, blanked_cursor, tw;
    union REGS regs;
    unsigned x, y;
    unsigned x0, y0, x1, y1;

    if (ms_status)
        ms_hide();
    if (graphics_mode) {
        reset_font();
        setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
        blanked_cursor = cursor_blanked;
        if (!blanked_cursor)
            cursor_off();
        th  = GrTextHeight();
        tw  = GrTextWidth();
        nl  = (GrTextMaxY - (GrTextCurrY + th) + 1) / th;
        y0 = GrTextCurrY / th;
        y1 = y0 + nl;
        x0 = GrTextLeft / tw;
        x1 = x0 + ((GrTextMaxX + 1) / tw);
        if (up_scrn_buff) {
            for (y=y0; y<y1; y++)
                for (x=x0; x<x1; x++)
                    (*screen_image)[y][x] = (*screen_image)[y+1][x];
            for (x=x0; x<x1; x++)
                (*screen_image)[y1][x] = GrFillChar;
        }
        regs.h.bh = GrBackground;
    }
    else {
        blanked_cursor = TRUE;
        regs.h.bh = (unsigned char) current_text_attr;
    }
    get_xy(&x,&y);
    regs.h.ch = y - 1;
    regs.h.cl = min_x_coord - 1;
    if (last_line < max_y_coord)
        regs.h.dh = last_line - 1;
    else
        regs.h.dh = max_y_coord - 1;
    regs.h.dl = max_x_coord - 1;
    regs.x.ax = 0x0601;
    int86(0x10,&regs,&regs);
    if (!blanked_cursor)
        cursor_on();
    if (ms_status)
        ms_show();
}

void wf_insline(int up_scrn_buff)
{
    int th, nl, blanked_cursor, tw;
    union REGS regs;
    unsigned x, y;
    unsigned x0, x1, y0, y1;

    if (ms_status)
        ms_hide();
    if (graphics_mode) {
        reset_font();
        setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
        blanked_cursor = cursor_blanked;
        if (!blanked_cursor)
            cursor_off();
        th = GrTextHeight();
        tw = GrTextWidth();
        nl = (GrTextMaxY - GrTextCurrY + 1) / th - 1;
        y0 = GrTextCurrY / th;
        y1 = y0 + nl;
        x0 = GrTextLeft / tw;
        x1 = x0 + ((GrTextMaxX + 1) / tw);
        if (up_scrn_buff) {
            for (y=y1; y>y0; y--)
                for (x=x1; x>x0; x--)
                    (*screen_image)[y][x] = (*screen_image)[y-1][x];
            for (x=x0; x<x1; x++)
                (*screen_image)[y0][x] = GrFillChar;
        }
        regs.h.bh = GrBackground;
    }
    else {
        blanked_cursor = TRUE;
        regs.h.bh = (unsigned char) current_text_attr;
    }
    get_xy(&x,&y);
    regs.h.ch = y - 1;
    regs.h.cl = min_x_coord - 1;
    if (last_line < max_y_coord)
        regs.h.dh = last_line - 1;
    else
        regs.h.dh = max_y_coord - 1;
    regs.h.dl = max_x_coord - 1;
    regs.x.ax = 0x0701;
    int86(0x10,&regs,&regs);
    if (!blanked_cursor)
        cursor_on();
    if (ms_status)
        ms_show();
}

void move_G_scrn(int xb,int yb,int ncols,unsigned *row_ptr,int up_scrn_buff)
{
    int f, b, x, ypix, xpix, tw, th, i, tot_w;
    unsigned attr, Char, Attr;
    char buf[128];

    tw = GrTextWidth();
    th = GrTextHeight();
    f  = getcolor();
    b  = GrBackground;
    xpix = max((xb * tw),0);
    ypix = max((yb * th),0);
    tot_w =
       i = 0;
    attr = 0x1000;
    for (x=0; x<ncols; x++) {
        Char = row_ptr[x];
        if ((Attr = (Char >> 8)) != attr) {
            if (i) {
                buf[i] = 0;
                GrWriteString(xpix,ypix,buf,tot_w,th,attr,up_scrn_buff);
                xpix += tot_w;
                tot_w =
                   i = 0;
            }
            attr = Attr;
        }
        buf[i++] = Char;
        tot_w += tw;
    }
    if (i) {
        buf[i] = 0;
        GrWriteString(xpix,ypix,buf,tot_w,th,attr,up_scrn_buff);
    }
    setcolor(f);
    GrBackground = b;
}

void move_scrollback_row(screen_array_ptr ptr,int ToScreen,int sb_row,int scr_row)
{
    int x, gy, ncols;
    struct settings *p;
    unsigned ix, iy;
    long row_idx;
    unsigned *row_ptr;

    row_idx = ((long)sb_row) * ((long)(SCREEN_MAX_WIDTH << 1));
    row_ptr = (unsigned *) farPtr((char *) ptr,row_idx);
    if (ms_status)
        ms_hide();
    ncols = scr_numcols;
//                          if (graphics_mode) {
//                              ncols = (GrTextMaxX + 1) / GrTextWidth();
//                              if (ncols > scr_numcols)
//                                  ncols = scr_numcols;
//                          }
    if (ToScreen) {
        if (graphics_mode) {
            getxy(&ix,&iy);
            p = save_settings();
            RIPfontsize = 0;
            reset_font();
            setviewport(0,0,X_max,Y_max,TRUE);
            move_G_scrn(0,scr_row,ncols,row_ptr,FALSE);
            restore_settings(p);
            reset_font();
            wf_gotoxy(ix,iy);
            goto MoveScrollExit;
        }
        for (x=0; x<ncols; x++)
	    (*scr_ptr)[scr_row][x] = row_ptr[x];
        gy = scr_row + 1;
        tell_dv_line(gy);
        goto MoveScrollExit;
    }
    if (graphics_mode) {
        for (x=0; x<ncols; x++)
            row_ptr[x] = (*screen_image)[scr_row][x];
    }
    else {
        for (x=0; x<ncols; x++)
	    row_ptr[x] = (*scr_ptr)[scr_row][x];
    }
MoveScrollExit:
    if (ms_status)
        ms_show();
}

void put_into_scrollback(int scr_row)
{
    move_scrollback_row((screen_array_ptr) scrollback_array_ptr,0,scrollback_end,scr_row);
    if (++scrollback_end > sb_highest) {
        scrollback_end = 0;
        scrollback_start = (-1);
    }
}

int get_from_scrollback(int scr_row,int *sb_cnt)
{
    int k;

    if ((k = scrollback_curr - 1) < 0)
        k = sb_highest;
    if ((k==scrollback_start)||(k==scrollback_end))
        return(1);
    scrollback_curr = k;
    wf_gotoxy(1,1);
    wf_insline(FALSE);
    move_scrollback_row((screen_array_ptr) scrollback_array_ptr,1,scrollback_curr,scr_row);
    (*sb_cnt)--;
    return(0);
}

int rev_scrollback(int scr_row,int *sb_cnt)
{
    int k_row;

    if (scrollback_curr == scrollback_end)
        return(1);
    if (++scrollback_curr > sb_highest)
        scrollback_curr = 0;
    wf_gotoxy(1,1);
    wf_delline(FALSE);
    if (*sb_cnt >= 0) {
        move_scrollback_row((screen_array_ptr) screen_image,1,*sb_cnt,scr_row);
    }
    else {
        if ((k_row = scrollback_curr + last_line - 1) > sb_highest)
            k_row -= (sb_highest + 1);
        move_scrollback_row((screen_array_ptr) scrollback_array_ptr,1,k_row,scr_row);
    }
    (*sb_cnt)++;
    return(0);
}

void wf_scroll(void)
{
    unsigned x, y;

    getxy(&x,&y);
    if (scrollback_array_ptr != NULL)
        put_into_scrollback(0);
    wf_gotoxy(1,1);
    wf_delline(TRUE);
    wf_gotoxy(x,y);
}
